<?php declare(strict_types = 1);

namespace Drupal\maintenance_window;

use Drupal\Core\ParamConverter\ParamConverterInterface;
use Drupal\maintenance_window\MaintenanceWindow;
use Drupal\maintenance_window\MaintenanceWindowRepository;
use Symfony\Component\Routing\Route;

/**
 * @todo Add description for the converter.
 *
 * @DCG
 * To use this converter specify parameter type in a relevant route as follows:
 * @code
 * maintenance_window.maintenance_window_parameter_converter:
 *   path: example/{record}
 *   defaults:
 *     _controller: '\Drupal\maintenance_window\Controller\MaintenanceWindowController::build'
 *   requirements:
 *     _access: 'TRUE'
 *   options:
 *     parameters:
 *       record:
 *        type: maintenance_window
 * @endcode
 *
 * Note that parameter converter for entities already exists in Drupal core.
 * @see \Drupal\Core\ParamConverter\EntityConverter
 */
final class MaintenanceWindowParamConverter implements ParamConverterInterface {

  /**
   * Constructs a MaintenanceWindowParamConverter object.
   */
  public function __construct(
    private readonly MaintenanceWindowRepository $maintenanceWindowRepository,
  ) {}

  /**
   * {@inheritdoc}
   */
  public function convert($value, $definition, $name, array $defaults): ?MaintenanceWindow {
    $window = $this->maintenanceWindowRepository->load((int) $value);
    return $window;
  }

  /**
   * {@inheritdoc}
   */
  public function applies($definition, $name, Route $route): bool {
    return isset($definition['type']) && $definition['type'] === 'maintenance_window';
  }

}
